package mygame;

import org.newdawn.slick.AppGameContainer;
import org.newdawn.slick.BasicGame;
import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;

/**
弾丸を連射できるようにしてみる。
@author フラチキさん
*/
public class MyGame05 extends BasicGame {
	// 自機スプライトの画像
	Image my_sprite;

	// 自機の座標
	int my_x;
	int my_y;

	// 自機の移動速度
	int my_speed = 10;

	/**
	コンストラクタ
	*/
	public MyGame05() {
		super("MyGame05");
	}

	/**
	最初に一回だけ実行される初期化。
	*/
	public void init(GameContainer container) throws SlickException {
		container.getGraphics().setBackground(new Color(0.4f,0.6f,0.6f));

		// ファイルからスプライト画像を読み込む。
		my_sprite = new Image("mygame/f15.png");
		bullet_sprite = new Image("mygame/gun.png");
	}

	/**
	毎フレーム実行される描画。
	*/
	public void render(GameContainer container, Graphics g) {
		// 自機スプライトを表示する。
		my_sprite.draw(my_x, my_y);
	}

	/**
	毎フレーム実行される更新。
	*/
	public void update(GameContainer container, int delta) {
		// プレイヤー機の移動
		Input input = container.getInput();
		if (input.isKeyDown(Input.KEY_LEFT))  my_x = my_x - my_speed;
		if (input.isKeyDown(Input.KEY_RIGHT)) my_x = my_x + my_speed;
		if (input.isKeyDown(Input.KEY_UP))    my_y = my_y - my_speed;
		if (input.isKeyDown(Input.KEY_DOWN))  my_y = my_y + my_speed;

		// プレイヤー機の移動範囲を制限
		int limit_x = (600 - 120);  // 画面右端の座標
		int limit_y = (800 - 178);  // 画面下端の座標
		if(my_x < 0)       my_x = 0;
		if(limit_x < my_x) my_x = limit_x;
		if(my_y < 0)       my_y = 0;
		if(limit_y < my_y) my_y = limit_y;
	}

	/**
	プログラムはここから実行される。
	@param argv プログラムの起動時に渡されたコマンドライン引数。
	*/
	public static void main(String[] argv) {
		try {
			AppGameContainer container = new AppGameContainer(new MyGame05());
			container.setDisplayMode(600,800,false);
			container.setTargetFrameRate(60);
			container.start();
		} catch (SlickException e) {
			e.printStackTrace();
		}
	}
}
